﻿using GeoAPI.Geometries;
using HEAL.Attic;
using SharpMap.Data.Providers;
using System;
using System.Collections.Generic;

namespace HeuristicLab.Problems.BioBoost.Persistence {
  public class StorableTypeMap : IStorableTypeMap {
    public IEnumerable<Tuple<Guid, Type>> KnownStorableTypes {
      get {
        yield return Tuple.Create(new Guid("C0423505-BFE3-441A-B859-9414E5DA8843"), typeof(GeometryFeatureProvider));
        yield return Tuple.Create(new Guid("9668D7D3-8EB1-4C78-B35E-206A1A967F05"), typeof(IGeometry));
        yield return Tuple.Create(new Guid("46AD44B0-25ED-4193-8B62-3FCEBFB4397E"), typeof(NetTopologySuite.Geometries.Point));
        yield return Tuple.Create(new Guid("8C7605E3-485D-4BC2-931D-F9CFD0462987"), typeof(NetTopologySuite.Geometries.MultiPoint));
        yield return Tuple.Create(new Guid("79699D23-2B0C-4470-99FD-5B08B3E62314"), typeof(NetTopologySuite.Geometries.LineString));
        yield return Tuple.Create(new Guid("EDB0B8F6-AFE0-4225-A0ED-F11D06AA590C"), typeof(NetTopologySuite.Geometries.MultiLineString));
        yield return Tuple.Create(new Guid("80929154-A48A-4CEB-B23A-952F3026F925"), typeof(NetTopologySuite.Geometries.Polygon));
        yield return Tuple.Create(new Guid("15191D96-A005-4BDE-BFFB-C011D4FCEE6B"), typeof(NetTopologySuite.Geometries.MultiPolygon));
        yield return Tuple.Create(new Guid("F9A1463F-FCAB-4D7B-B9EE-513564EA4D4A"), typeof(NetTopologySuite.Geometries.Geometry));
        yield return Tuple.Create(new Guid("1500FC16-421B-4FAB-89A0-7DA92C441F64"), typeof(NetTopologySuite.Geometries.GeometryCollection));

      }
    }
  }
}
